class Objects {
 
  int            _type;
  float          _state;
  color          _filling;
  color          _stroke;
  int            _strokeWeight;
  boolean        _extremeMode;
  
  Objects(int type, float state, ArrayList options) {
  
    this._type = type;
    this._state = state;
    this._filling = (color)(Integer)options.get(0);
    this._stroke = (color)(Integer)options.get(1);
    this._strokeWeight = (Integer)options.get(2);
    
    this._extremeMode = false;
    
  }
  
  void draw() {
    
  /*  switch(this._type % 5) {

      case 0:
      case 1:
      case 2:
      case 3:
      case 4:*/
        square();
/*      break;
      case 5:
      break;
      case 6:

      break;
      case 7:

      break;
      case 8:

      break;
      case 9:

      break;      
    }*/
    
  }

  color getfilling() {
    
    return this._filling;
    
  }

  float getState() {
    
    return this._state;
    
  }
  
  int getType() {
    
    return this._type;
    
  }

  void setfilling(color filling) {
    
    this._filling = filling;
    
  }
  
  void setState(float state) {
    
    this._state = state;
    
  }
  
  void setType(int type) {
    
    this._type = type;
    
  }
  
  /*void square() {
    
    fill(this._filling);
    stroke(this._filling);
    
    shapeMode(CENTER);
    
    float objectWidth = workspace.x / (gridAxisSize * 1.5);

    beginShape();
     vertex(0, 0);
     bezierVertex(0, 0, 0, objectWidth, 0, objectWidth);
     bezierVertex(0, objectWidth, objectWidth, objectWidth, objectWidth, objectWidth);
     bezierVertex(objectWidth, objectWidth, objectWidth, 0, objectWidth, 0);
     bezierVertex(objectWidth, 0, 0, 0, 0, 0);
     endShape();
     stroke(255);
    endShape();
        
  }*/
  
  void square() {
        
    fill(this._filling);
    stroke(this._stroke);
    strokeWeight(this._strokeWeight);
    
    shapeMode(CENTER);
    
    float objectWidth = workspace.x / (gridAxisSize * 1.5);

    if(this._extremeMode == true) {
  
      for(int j = 0; j < 6; j++) {
    
        pushMatrix();
  
          scale(1 - ((this._state + this._type) / 9) * 0.5);
          
          switch(j) {
            
            case 0:
            break;
            case 1:
              translate(0, 0, -objectWidth);
            
              rotateX(radians(90));
            break;
            case 2:
              translate(0, objectWidth, -objectWidth);
            
              rotateX(radians(90));
            break;
            case 3:
              translate(0, 0, 0);
            
              rotateY(radians(90));          
            break;
            case 4:
              translate(objectWidth, 0, 0);
            
              rotateY(radians(90));                    
            break;
            case 5:
              translate(0, 0, -objectWidth);          
            break;
            
          }
          
          beginShape();
            vertex(0, 0);
            bezierVertex(-objectWidth * 0.25 * (this._state + this._type), objectWidth * 0.25 * (this._state + this._type), -objectWidth * 0.25 * (this._state + this._type), objectWidth - objectWidth * 0.25 * (this._state + this._type), 0, objectWidth);
            bezierVertex(objectWidth * 0.25 * (this._state + this._type), objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth - objectWidth * 0.25 * (this._state + this._type), objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth, objectWidth);
            bezierVertex(objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth - objectWidth * 0.25 * (this._state + this._type), objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth * 0.25 * (this._state + this._type), objectWidth, 0);
            bezierVertex(objectWidth - objectWidth * 0.25 * (this._state + this._type), -objectWidth * 0.25 * (this._state + this._type), objectWidth * 0.25 * (this._state + this._type), -objectWidth * 0.25 * (this._state + this._type), 0, 0);
          endShape();
         
        popMatrix();
       
      }
          
    } else {
     
      beginShape();
        vertex(0, 0);
        bezierVertex(-objectWidth * 0.25 * (this._state + this._type), objectWidth * 0.25 * (this._state + this._type), -objectWidth * 0.25 * (this._state + this._type), objectWidth - objectWidth * 0.25 * (this._state + this._type), 0, objectWidth);
        bezierVertex(objectWidth * 0.25 * (this._state + this._type), objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth - objectWidth * 0.25 * (this._state + this._type), objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth, objectWidth);
        bezierVertex(objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth - objectWidth * 0.25 * (this._state + this._type), objectWidth + objectWidth * 0.25 * (this._state + this._type), objectWidth * 0.25 * (this._state + this._type), objectWidth, 0);
        bezierVertex(objectWidth - objectWidth * 0.25 * (this._state + this._type), -objectWidth * 0.25 * (this._state + this._type), objectWidth * 0.25 * (this._state + this._type), -objectWidth * 0.25 * (this._state + this._type), 0, 0);
      endShape();
      
    }
        
  }
  
}
